enum Order:
  case LessThan
  case Equal
  case GreaterThan

trait Ordered[T]:
  def compare(a: T, b: T): Order

def compare[T](a: T, b: T)(implicit order: Ordered[T]): Order =
  order.compare(a,b)

implicit class OrderOperators[T](a: T)(implicit order: Ordered[T]):
  def >(b: T): Boolean = compare(a,b) == Order.GreaterThan
  def <(b: T): Boolean = compare(a,b) == Order.LessThan