case class Rational(num: Int, denom: Int)

object Rational:
  implicit object OrderedRational extends Ordered[Rational]:
    def compare(a: Rational, b: Rational): Order = 
      a.num * b.denom - b.num * a.denom match
        case x if x > 0 => Order.GreaterThan
        case x if x < 0 => Order.LessThan
        case _ => Order.Equal